﻿
using System;
using System.IO;

namespace Digiwin.Common.Torridity.Serialization {

    internal abstract class DataEncoder {

        /// <summary>
        /// 返回写入器支持的类型。
        /// </summary>
        public abstract Type ValueType { get; }

        /// <summary>
        /// 创建对应的数组
        /// </summary>
        /// <param name="length"></param>
        /// <returns></returns>
        public abstract Array CreateArray(int length);

        /// <summary>
        /// 向流中写入指定的数组数据，不要写入数组的大小，外部会统一写入。
        /// </summary>
        /// <param name="context">序列化器上下文</param>
        /// <param name="values">数据</param>
        public abstract void Write(SerializeContext context, Array values);

        /// <summary>
        /// 从流中读取指定大小的数组数据。
        /// </summary>
        /// <param name="context">序列化器上下文</param>
        /// <param name="length">数组的大小</param>
        /// <returns>一个可用的数组</returns>
        public abstract Array Read(SerializeContext context, int length);
    }
}