﻿
using System;
using System.IO;

namespace Digiwin.Common.Torridity.Serialization {

    internal abstract class DataEncoder<T> : DataEncoder {

        sealed public override Type ValueType {
            get { return typeof(T); }
        }

        sealed public override Array CreateArray(int size) {
            return new T[size];
        }

        sealed public override void Write(SerializeContext context, Array values) {
            this.WriteCore(context, (T[])values);
        }

        protected abstract void WriteCore(SerializeContext context, T[] values);

        sealed public override Array Read(SerializeContext context, int length) {
            return this.ReadCore(context, length);
        }

        protected abstract T[] ReadCore(SerializeContext context, int length);
    }
}